var cfg;

(function (win, doc) {

if (win.opera.version() < 11.50) { return; }

var
	rgxIsSVG = /svgz?$/i,
	oex = opera['extension'],
	root = doc.documentElement,
	img = doc.querySelector('html:root>body img[src=""]'),
	isRaster = (img || {src: null}).src == win.location.href,
	isSVG = !isRaster && (doc instanceof win['SVGDocument'] || (root && root.nodeName.indexOf('svg') === 0) || rgxIsSVG.test(win.location.pathname));

if (isSVG && win.location.hash.indexOf('#IMAGUS_SVG') > -1) {
	if (win.location.hash.indexOf('#IMAGUS_SVG_GET') > -1) {
		var i = 10, wh,
		sendDimensions = function () {
			if (!doc.documentElement) { return; }
			doc.documentElement.suspendRedraw && doc.documentElement.suspendRedraw(5000);
			if (isSVG = doc.documentElement.nodeName.indexOf('svg') === 0) {
				wh = {'w': parseInt(doc.documentElement.getAttribute('width'), 10), 'h': parseInt(doc.documentElement.getAttribute('height'), 10)};

				if (!wh['w'] || !wh['h']) {
					wh = doc.documentElement['getBBox']();
					if (!(!isNaN(parseFloat(wh.width)) && isFinite(wh.width))) { return; }
					wh = {'w': wh.width, 'h': wh.height};
				}
			}

			clearInterval(interv);
			oex.postMessage({'cmd': 'svg_info', 'svg': isSVG, 'url': win.location.href, 'wh': wh});
		},
		interv = setInterval(function () { sendDimensions(); if (--i) { clearInterval(interv); return; } }, 500);

		doc.documentElement && sendDimensions();
	}

	return;
}

var notGranted = function (feature) {
	var i, j, rgxSite, blockaccess = false, grnts = cfg.tools.grants || [], cleanSieve = {};

	if (grnts && !grnts.length) { return blockaccess; }

	for (i = 0; i < grnts.length; ++i) {
		if (grnts[i][0] === null || grnts[i][0] == feature) {
			if (grnts[i][1] == '*' || ((grnts[i][2] === 1 || grnts[i][2] === 0) && (new RegExp(grnts[i][1], 'i')).test(win.location.href)) || win.location.href.indexOf(grnts[i][1]) > -1) {
				if (grnts[i][3]) {
					if (grnts[i][2]) {
						for (j = 0; j < grnts[i][3].length; ++j) { cleanSieve[grnts[i][3][j]] = true; }
					}
					else {
						for (j in cfg.sieve) { cleanSieve[j] = true; }
						for (j = 0; j < grnts[i][3].length; ++j) { cleanSieve[grnts[i][3][j]] = false; }
					}
				}
				else {blockaccess = grnts[i][2] ? true : false;}
			}
		}
	}

	for (i in cleanSieve) { if (cleanSieve[i]) { delete cfg.sieve[i]; blockaccess = false; } }

	return blockaccess;
},
convertSieveFunctions = function () {
	var i, isfunc = /^:\n/;
	for (var i in cfg.sieve) {
		if (cfg.sieve[i].to && isfunc.test(cfg.sieve[i].to)) {
			cfg.sieve[i].to = new Function('var $ = arguments;' + cfg.sieve[i].to.substr(2));
		}
	}
}

if (isRaster/* || (doc instanceof win['SVGDocument'] && doc.URL == win.top.location.href)*/) {
	oex.addEventListener('message', function (e) {
		if (!e.data['hello']) { return; }

		cfg = e.data['prefs'];

		if (cfg.vw.dam === 4 || notGranted('vw')) { return; }

		img.naturalWidth = 0;
		img.error = true;

		if (cfg.vw.dam === 5) {
			doc.body.style.padding = '0';
			img.onclick = win.onkeypress = win.onmousedown = win.onmouseup = win.onmousemove = null;
			return;
		}

		cfg.hz = false;

	//if (isRaster) {
		doc['head'].innerHTML = '';
		doc.body.innerHTML = '';

		if (PVI) {
			if (cfg.vw['detectLarger']) {
				convertSieveFunctions();
				PVI.target = doc.createElement('node');
				PVI.target.href = PVI.target.src = win.location.href;
				PVI.target.style.backgroundImage = 'none';
				PVI = PVI.find();

				if (Array.isArray(PVI)) {
					for (var i = 0; i < PVI.length; ++i) {
						if (PVI[i] == win.location.href) {
							PVI = PVI.slice(0, i);
							if (!PVI.length) { PVI = null; }
							break;
						}
					}
				}
				else if (PVI == win.location.href) { PVI = null; }

				if (PVI && cfg.vw['detectLarger'] === 1 && !win.confirm(LN('IMG_LARGERAVAIL') + '\n')) { PVI = null; }
			}
			else { PVI = null; }

			if (PVI) {
				if (rgxIsSVG.test(PVI)) {
					win.location.href = PVI;
					return;
				}
				else {
					try {win.history.pushState(null, null, PVI);} catch (ex) {}
				}
			}
		}

		img = new Image();

		img.onerror = function() {
			img = {error: true};
			doc.body.innerHTML = '<h2 style="padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff;font-family:Verdana">' + LN('IMG_FAILED') + '</h2>';
		};

		img.src = typeof PVI == 'string' ? PVI : win.location.href;

		if (img.src.indexOf('data:') === 0) {
			img.alt = 'Image (inline)';
			doc.title = 'Image';
		}
		else {
			// TODO: always gets the location pathname, but if larger image is detected it must use the new name
			img.alt = decodeURIComponent(win.location.pathname.match(/(?:[^\/]+)?$/)[0] + win.location.search) || 'Image';
		}

		if (img.naturalWidth === 0) {
			doc.body.innerHTML = '<h2 style="padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff;font-family:Verdana">' + img.alt + '</h2>';
			doc.body.firstElementChild.onclick = function () { this.parentNode.appendChild(img); this.parentNode.removeChild(this); };
		}
	/*}
	else {
		return;
		var img = '';
	}*/

		if (img.error) { return; }

		var sX, sY,
		noFit = {cur: false, real: false},
		progress = null,
		cancelAction = false,
		fZoom = null,
		pixelThresHold = cfg.vw.pixelmove,
		dragScroll = [],
		borderSize = 0,
		init = {loop: 0, wait: 300, maxLoop: 1000},
		MAXSIZE = 0x7fff, // maybe it should remove, because of Opera 12
		nodeStyle = 'width:100%;height:100%;',
		docStyle = 'body{margin:0;font:12px Verdana,"DejaVu Sans"}.m_1{max-width:100%;max-height:100%;width:auto;height:auto}.m_2{width:100%;height:auto}.m_3{height:100%;width:auto}';

		root || (root = doc.documentElement);

		if (!/^[bts]:/.test(cfg.vw.imgInfo)) { cfg.vw.imgInfo = false; }
/*		else if (cfg.vw.imgInfo[0] == 's') {
			doc.addEventListener('mouseover', img.imgInfo, false);
			doc.addEventListener('mouseup', img.imgInfo, false);
		}*/

		doc.body.style.cssText = nodeStyle;

		// scrollbars
		if (cfg.vw.hideSB) {
			nodeStyle += 'overflow:hidden;';
		}

		// background
		if (!!cfg.vw.backg) {
			if (cfg.vw.backg == 'cb') {
				nodeStyle += 'background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7);';
			}
			else if (/(?:http|-o-)/i.test(cfg.vw.backg)) { nodeStyle += 'background-image:' + cfg.vw.backg + ';'; }
			else { nodeStyle += 'background-color:' + cfg.vw.backg + ';'; }
		}

		if (nodeStyle !== '') {
			root.style.cssText = nodeStyle;
		}

		nodeStyle = '';

		// image background
		if (!!cfg.vw.imgBg) {
			if (cfg.vw.imgBg == 'cb') {
				nodeStyle += 'background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7);';
			}
			else if (/(?:http|-o-)/i.test(cfg.vw.imgBg)) { nodeStyle += 'background-image:' + cfg.vw.imgBg + ';'; }
			else { nodeStyle += 'background-color:' + cfg.vw.imgBg + ';'; }
		}

		if (!!cfg.vw.imgBorder) {
			nodeStyle += 'border:' + (img.style.border = cfg.vw.imgBorder) + ';';
			borderSize = parseInt(cfg.vw.imgBorder, 10);

			if (borderSize > 100) {
				borderSize = 100;
				nodeStyle += 'border-width:' + borderSize + 'px !important;';
			}

			nodeStyle += 'background-clip:padding-box;box-sizing:border-box;';
		}

		docStyle += 'img{position:absolute;' + nodeStyle + '}';

		var load = function(noneedinterval) {
			if (img.error) {
				if (progress) { clearInterval(progress); }
				return;
			}

			if (img.width > 0 || noneedinterval) {
				clearInterval(progress);
				progress = null;

				if (!img.naturalWidth) {
					img.naturalWidth = img.width;
					img.naturalHeight = img.height;
				}

				doc['head'].innerHTML = '<style>' + docStyle + 'body>img{max-width:' + Math.min(MAXSIZE, Math.floor(img.naturalWidth * MAXSIZE / img.naturalHeight)) + 'px;max-height:' + Math.min(MAXSIZE, Math.floor(img.naturalHeight * MAXSIZE / img.naturalWidth)) + 'px}' + '</style>';

				img.style.visibility = 'hidden';
				doc.body.innerHTML = '';
				doc.body.appendChild(img);

				// Opera does not support images larger than ??MP
				/*if (img.naturalWidth * img.naturalHeight > 100 * 10E6) {
					doc.body.innerHTML = '<h2>' + LN('IMG_TOO_LARGE') + '</h2>';
					return;
				}*/

				img.resize = function(m, w, h) {
					if (m === 4) {
						cfg.vw.dam = 4;
						this.style.display = 'none';
						this.parentNode.style.backgroundImage = 'url("'+this.src+'")';
						this.setPos();
						return;
					}
					else if (cfg.vw.dam === 4) {
						this.style.display = 'run-in';
						this.parentNode.style.backgroundImage = '';
					}
					else if (m === -1 || (m === -1 && fZoom)) {
						this.style.width = w;
						h && (this.style.height = h);

						if ((w === '' || w === this.naturalWidth) && (h === '' || h === this.naturalHeight)) {
							m = 0;
						}
					}

					if (m !== -1 && cfg.vw.dam === -1) {
						this.style.width = this.style.height = '';
					}

					this.className != 'm_' + m && (this.className = 'm_' + m);

					cfg.vw.dam = m;

					if (this.naturalWidth && this.naturalHeight && this.calcFit) {
						this.setPos();
						this.calcFit();
						this.hScroll();
						this.setCur();
						this.setInfo();
					}
				};

				img.setInfo = function() {
					if (!cfg.vw.imgInfo || !(img.naturalWidth && img.naturalHeight)) { return; }

					var fc = cfg.vw.imgInfo.charAt(0),
						info = cfg.vw.imgInfo.substr(2).replace('%w', img.width).replace('%h', img.height).replace('%ow', img.naturalWidth).replace('%oh', img.naturalHeight).replace('%url', win.location).replace('%name', img.alt);

					if (cfg.vw.imgInfo.indexOf('%perc') > 0) { info = info.replace('%perc', (~~(0.5 + 1E4 * (img.width / img.naturalWidth)) / 100)); }

					if (fc == 't') { doc.title = info; }
					else if (fc == 's') { win.status = info; }
					else if (fc == 'b') { doc.title = win.status = info; }
				};

				var hLayer, createHelper = function () {
					if (hLayer) { return; }

					hLayer = doc.createElement('div');
					hLayer.style.cssText = 'position:fixed;display:none;z-index:665;left:0px;top:0px;width:100%;height:100%;box-sizing:border-box;background-clip:padding-box;white-space:nowrap;color:#fff;text-shadow:1px 1px 1px #000;overflow:hidden';
					doc.body.appendChild(hLayer);
				};

				img.setPos = function() {
					if (cfg.vw.pos.length === 2) {
						var bgM = (cfg.vw.dam === 4), bgPos = '';

						var r = this.currentdeg && Math.sin(this.currentdeg) > 0 ? true : false;

						switch (cfg.vw.pos.charAt(1)) {
							case '0' : if (bgM) { bgPos = 'top '; } else { this.style.top = '0px'; } break;
							case '2' : if (bgM) { bgPos = 'bottom '; } else { this.style.top = Math.max(0, root.clientHeight - (r ? this.width : this.height) - borderSize * 2) + 'px'; } break;
							default: if (bgM) { bgPos = 'center '; } else { this.style.top = Math.max(0, (root.clientHeight - (r ? this.width : this.height)) / 2 - borderSize) + 'px'; } break;
						}

						switch (cfg.vw.pos.charAt(0)) {
							case '0' : if (bgM) { bgPos += 'left'; } else { this.style.left = '0px'; } break;
							case '2' : if (bgM) { bgPos += 'right'; } else { this.style.left = Math.max(0, root.clientWidth - (r ? this.height : this.width) - borderSize * 2) + 'px'; } break;
							default : if (bgM) { bgPos += 'center'; } else { this.style.left = Math.max(0, (root.clientWidth - (r ? this.height : this.width)) / 2 - borderSize) + 'px'; } break;
						}

						if (bgM) { this.parentNode.style.backgroundPosition = bgPos; }
					}
				};

				img.calcFit = function () {
					noFit = {
						cur: (this.width <= win.innerWidth && this.height <= win.innerHeight),
						real: (this.naturalWidth <= win.innerWidth && this.naturalHeight <= win.innerHeight)
					};
				};

				img.wheelZoom = function (e) {
					e.preventDefault();

					var w = img.width + 2 * borderSize, h = img.height + 2 * borderSize;

					if (e.wheelDelta > 0) {
						var width = w * (e.altKey || e.accelerate ? 1.4 : 1.2);

						img.resize(-1, (width > 10 ? width : width + 3) + 'px', 'auto');
					}
					else {
						img.resize(-1, Math.max(1, w * (e.altKey || e.accelerate ? 0.6 : 0.8)) + 'px', 'auto');
					}

					if ((e.target.nodeName.toUpperCase() == 'IMG' || e.keypress)) {
						win.scrollTo(e.offsetX * (img.width + 2 * borderSize) / w - e.clientX + borderSize, e.offsetY * (img.height + 2 * borderSize) / h - e.clientY + borderSize);
					}
				};

				if (cfg.vw.scrollZoom) {
					img.hScroll = function () {};

					doc.addEventListener('mousewheel', img.wheelZoom, false);
				}
				else {
					if (cfg.vw.hideSB) {
						var onWheelVertical = function (e) {
							win.scrollBy(0, -e.wheelDelta);
							e.preventDefault();
						};

						doc.addEventListener('mousewheel', onWheelVertical, false);
					}

					var onWheelHorizontal = function (e) {
						win.scrollBy(-e.wheelDelta, 0);
						e.preventDefault();
					};

					img.hScroll = function (force) {
						var hS;

						switch (cfg.vw.dam) {
							case -1:
							case 0: hS = (win.innerWidth < this.width && cfg.vw.hlonger && this.height <= (this.width / cfg.vw.hlonger) ? true : false); break;
							case 3: hS = (win.innerWidth < this.width ? true : false); break;
							default: hS = false; break;
						}

						if (force) {
							hS = !hS;

							win.onkeyup = function(e) {
								if (e.keyCode === 88) {
									img.hScroll();
									win.onkeyup = null;
								}
							};
						}
						if (hS) { doc.addEventListener('mousewheel', onWheelHorizontal, false); if (cfg.vw.hideSB) { doc.removeEventListener('mousewheel', onWheelVertical, false); }}
						else { doc.removeEventListener('mousewheel', onWheelHorizontal, false); if (cfg.vw.hideSB) { doc.addEventListener('mousewheel', onWheelVertical, false); }}
					};
				}

				if (cfg.vw.cursor) {
					img.setCur = function () {
						if (this.width > win.innerWidth || this.height > win.innerHeight) {
							this.style.cursor = 'move';
						}
						else if (((win.innerHeight >= this.height && win.innerWidth >= this.width) && (win.innerHeight < this.naturalHeight || win.innerWidth < this.naturalWidth)) ||
						(noFit.cur && noFit.real && (this.height < this.naturalHeight || this.width < this.naturalWidth))) {
							this.style.cursor = 'zoom-in';
						}
						else { this.style.cursor = 'default'; }
					};
				}
				else {
					img.setCur = function () {};
				}

				win.addEventListener('resize', function () {
					img.setPos();
					img.calcFit();
					img.hScroll();
					img.setCur();
					img.setInfo();
				}, false);

				var cxmenu, contextmenu = function (mx, my) {
					createHelper();

					if (cxmenu) {
						cxmenu.style.left = mx + 'px';
						cxmenu.style.top = my + 'px';
						hLayer.style.border = 0;
						hLayer.style.left = 0;
						hLayer.style.top = 0;
						hLayer.style.width = '100%';
						hLayer.style.height = '100%';
						hLayer.appendChild(cxmenu);
						hLayer.style.display = 'block';
						return;
					}

					/*-o-transition:opacity 300ms;opacity:0;*/
					doc['head'].firstChild.innerText += '#O_EX_CM{display:none;position:fixed;text-shadow:none;z-index:666}#O_EX_CM,#O_EX_CM ul{background-color:#f0f0f0;border:1px solid #a0a0a0;box-shadow:2px 2px 2px #8e8e8e;display:inline-block;list-style:none;margin:0;padding:2px}#O_EX_CM li{position:relative}#O_EX_CM li ul{display:none;left:100%;position:absolute;top:-5px}#O_EX_CM li:hover ul{display:block}#O_EX_CM li a+i{color:grey;font-style:normal;position:absolute;right:5px;text-shadow:0 0 1px #fff;top:2px}#O_EX_CM .title{color:silver;letter-spacing:1px;padding:10px 5px 6px;text-shadow:0 0 0 #000}#O_EX_CM li:empty{border-bottom:1px solid #fff;border-top:1px solid #a0a0a0;margin:5px 7px 4px}#O_EX_CM .title:first-child{padding-top:0}#O_EX_CM a{border:1px solid transparent;color:#000;cursor:default;display:block;padding:2px 45px 2px 10px;text-decoration:none;white-space:nowrap}#O_EX_CM a:hover{background-color:#46a9ff;border:1px solid #1676ff;color:#fff}#O_EX_CM a:hover+i{color:#fff}';
					cxmenu = doc.createElement('ul');
					cxmenu.id = 'O_EX_CM';

					hLayer.appendChild(cxmenu);

					var generateMenu = function (ext_menu_data) {
						var tmpel, mfragment = doc.createDocumentFragment(), a, key, i, l;

						for (i = 0, l = ext_menu_data.length; i < l; ++i) {
							if (!ext_menu_data[i].length) {
								mfragment.appendChild(doc.createElement('li'));
							}
							else if (Array.isArray(ext_menu_data[i][1])) {
								if (!ext_menu_data[i][1].length) { continue; }

								tmpel = doc.createElement('li');
								a = doc.createElement('a'); ul = doc.createElement('ul');
								a.innerText = ext_menu_data[i][0];
								tmpel.appendChild(a);

								if (ext_menu_data[i][2]) {
									key = doc.createElement('i');
									key.innerHTML = ext_menu_data[i][2];
									tmpel.appendChild(key);
								}

								ul.appendChild(generateMenu(ext_menu_data[i][1]));
								tmpel.appendChild(ul);
								mfragment.appendChild(tmpel);
							}
							else {
								tmpel = doc.createElement('li');
								a = doc.createElement('a');
								a.innerText = ext_menu_data[i][0];

								if (ext_menu_data[i][1]) { a.onclick = ext_menu_data[i][1]; }
								tmpel.appendChild(a);

								if (ext_menu_data[i][2]) {
									key = doc.createElement('i');
									key.innerText = ext_menu_data[i][2];
									tmpel.appendChild(key);
								}

								mfragment.appendChild(tmpel);
							}
						}

						return mfragment;
					};

					var $searchHosts = [], tmpel, mfragment = doc.createDocumentFragment();

					tmpel = doc.createElement('li');
					tmpel.className = 'title';
					tmpel.innerText = 'Imagus';
					mfragment.appendChild(tmpel);

					if (cfg.tools['imgSearchHosts'].length) {
						for (var shidx = 0; shidx < cfg.tools['imgSearchHosts'].length; ++shidx) {
							$searchHosts.push([cfg.tools['imgSearchHosts'][shidx][0].replace(/^\+/, ''), function(sf){return function(){ imageSearch(sf); }}({'url': img.src, 'host': shidx})]);
						}

						$searchHosts.push([LN('WITH_ALL'), function() { imageSearch({'url': img.src, 'host': -1}); }, String.fromCharCode(cfg.tools['key_imgSearch'])]);
					}

					mfragment.appendChild(generateMenu([
						[LN('ORIGINAL_SIZE'), function() { img.resize(0); }, String.fromCharCode(cfg.tools['key_modeAuto'])],
						[LN('BEST_FIT'), function() { img.resize(1); }, String.fromCharCode(cfg.tools['key_modeFit'])],
						[LN('FIT_TO_WIDTH'), function() { img.resize(2); }, String.fromCharCode(cfg.tools['key_modeFitW'])],
						[LN('FIT_TO_HEIGHT'), function() { img.resize(3); }, String.fromCharCode(cfg.tools['key_modeFitH'])],
						[LN('MORE'), [
							[LN('TO_BACKGROUND'), function() { img.resize(4); }, String.fromCharCode(cfg.tools['key_modeBg'])],
							[LN('CUSTOM_SIZE'), function() { img.setSize(); }, String.fromCharCode(cfg.tools['key_customSize'])],
							[LN('RESET_IMAGE'), function() { img.reset(true); }, 'Esc']
						], '&#187;'],
						[],
						[LN('TRANSFORM'), [
							[LN('FLIP_H'), function() { img.flip(1); }, String.fromCharCode(cfg.tools['key_flipH'])],
							[LN('FLIP_V'), function() { img.flip(0); }, String.fromCharCode(cfg.tools['key_flipV'])],
							[],
							[LN('ROT_LEFT'), function() { img.rotate(false); }, String.fromCharCode(cfg.tools['key_rotateLeft'])],
							[LN('ROT_RIGHT'), function() { img.rotate(true); }, String.fromCharCode(cfg.tools['key_rotateRight'])],
							[LN('ROT_CUSTOM'), function() { img.rotate(); }, String.fromCharCode(cfg.tools['key_rotateCustom'])]
						], '&#187;'],
						[LN('IMG_SEARCH'), $searchHosts, '&#187;'],
						[LN('PREFERENCES'), function () { oex.postMessage({'cmd': 'open', 'url': 'options.html'}); }, String.fromCharCode(cfg.tools['key_prefs'])]
					]));

					cxmenu.style.cssText = 'left:' + mx + 'px;top:' + my + 'px;display:block';
					cxmenu.appendChild(mfragment);

					hLayer.style.border = 0;
					hLayer.style.left = 0;
					hLayer.style.top = 0;
					hLayer.style.width = '100%';
					hLayer.style.height = '100%';
					hLayer.style.display = 'block';
				};

				doc.addEventListener('contextmenu', function(e) {
					win.onmousemove = null;
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction === 2) { cancelAction = false; e.preventDefault(); }
				}, false);

				var onmove = function (e) {
					if (fZoom) {
						if (fZoom.stage === 0) {
							if (!e.shiftKey) {
								fZoom = null;
								return;
							}

							createHelper();
							hLayer.innerHTML = '';
							cxmenu = null;

							var rot = img.currentdeg && Math.sin(img.currentdeg) ? true : false,
								w = rot ? img.height : img.width,
								h = rot ? img.width : img.height;
							if (w > win.innerWidth) {
								hLayer.style.left = parseInt(borderSize, 10);
								hLayer.style.width = win.innerWidth + 'px';
							}
							else {
								hLayer.style.left = (img.offsetLeft + borderSize) + 'px';
								hLayer.style.width = w + 'px';
							}

							if (h > win.innerHeight) {
								hLayer.style.top = parseInt(borderSize, 10);
								hLayer.style.height = win.innerHeight + 'px';
							}
							else {
								hLayer.style.top = (img.offsetTop + borderSize) + 'px';
								hLayer.style.height = h + 'px';
							}

							// helper width, height
							fZoom.hW = parseInt(hLayer.style.width, 10);
							fZoom.hH = parseInt(hLayer.style.height, 10);

							// helper top, left
							fZoom.hT = parseInt(hLayer.style.top, 10);
							fZoom.hL = parseInt(hLayer.style.left, 10);

							// helper right, bottom
							fZoom.hR = fZoom.hL + fZoom.hW;
							fZoom.hB = fZoom.hT + fZoom.hH;

							fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
							fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
							fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
							fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);

							// area width, height
							//fZoom.sW = Math.max(0, fZoom.hW - fZoom.hL - fZoom.hR);
							//fZoom.sH = Math.max(0, fZoom.hH - fZoom.hT - fZoom.hB);

							hLayer.style.borderStyle = 'solid';
							hLayer.style.borderColor = 'rgba(0,0,0,.5)';
							//hLayer.style.backgroundColor = 'rgba(0,255,255,.5)';
							hLayer.style.borderWidth = fZoom.t + 'px ' + fZoom.r + 'px ' + fZoom.b + 'px ' + fZoom.l + 'px';
							hLayer.style.display = 'block';

							++fZoom.stage;
						}
						else {
							if (e.ctrlKey) {
								if (fZoom.sX) {
									var x = fZoom.sX - e.screenX, y = fZoom.sY - e.screenY;

									if (y !== 0) {
										hLayer.style.borderBottomWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderBottomWidth, 10) + y), fZoom.hH) + 'px';
										hLayer.style.borderTopWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderTopWidth, 10) - y), fZoom.hH) + 'px';
									}

									if (x !== 0) {
										hLayer.style.borderRightWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderRightWidth, 10) + x), fZoom.hW) + 'px';
										hLayer.style.borderLeftWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderLeftWidth, 10) - x), fZoom.hW) + 'px';
									}
								}

								fZoom.sX = e.screenX;
								fZoom.sY = e.screenY;

								return;
							}

							if (fZoom.sX) {
								fZoom.sX = null;
								fZoom.sY = null;
								/*fZoom.cX = fZoom.hL + (fZoom.cX < e.clientX ? parseInt(hLayer.style.borderLeftWidth, 10) : fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10));
								fZoom.cY = fZoom.hT + (fZoom.cY < e.clientY ? parseInt(hLayer.style.borderTopWidth, 10) : fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10));*/
								if (fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10) < e.clientX) { fZoom.cX = fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10); }
								else { fZoom.cX = fZoom.hL + fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10); }

								if (fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10) < e.clientY) { fZoom.cY = fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10); }
								else { fZoom.cY = fZoom.hT + fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10); }

								//borders
								fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
								fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
								fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
								fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);
							}

							var t, r, b, l;

							if (fZoom.cY < e.clientY) {
								b = Math.max(0, fZoom.hB - e.clientY);
								t = fZoom.t;
							}
							else {
								b = fZoom.b;
								t = Math.max(0, e.clientY - fZoom.hT);
							}

							if (fZoom.cX < e.clientX) {
								r = Math.max(0, fZoom.hR - e.clientX);
								l = fZoom.l;
							}
							else {
								r = fZoom.r;
								l = Math.max(0, e.clientX - fZoom.hL);
							}

							hLayer.style.borderWidth = t + 'px ' + r + 'px ' + b + 'px ' + l + 'px';
						}

						return;
					}

					if (progress) { clearTimeout(progress); progress = null;}

					if (sX === true || cfg.vw.pixelmove < 1 || noFit.cur || !parseInt(cfg.vw.pixelmove, 10)) { win.onmousemove = null; return;}

					if (!--pixelThresHold) {
						win.scrollBy(sX - e.screenX, sY - e.screenY);

						sX = e.screenX;
						sY = e.screenY;
						pixelThresHold = cfg.vw.pixelmove;
					}

					if (dragScroll.length !== 3) {
						dragScroll = [ [e.screenX, e.screenY], [e.screenX, e.screenY], [e.screenX, e.screenY] ];
						return;
					}

					//dragScroll = [[dragScroll[1][0], dragScroll[1][1]], [dragScroll[2][0], dragScroll[2][1]], [e.screenX, e.screenY]];

					dragScroll[0] = [dragScroll[1][0], dragScroll[1][1]];
					dragScroll[1] = [dragScroll[2][0], dragScroll[2][1]];
					dragScroll[2] = [e.screenX, e.screenY];

					img.dragScrollTime = Date.now();
				};

				if (cfg.vw.dragScroll) {
					var stopScroll = function (e, c_action) {
						if (dragScroll.length) {
							clearInterval(progress);
							progress = null;
							cancelAction = c_action ? true : false;
							dragScroll = [];
							img.dragScrollTime = false;
						}

						if (e) {
							doc.removeEventListener('mousewheel', stopScroll, false);
						}
					};

					var scroll = function () {
						win.scrollBy(dragScroll[0], dragScroll[1]);

						if (dragScroll[0]) {
							if (Math.abs(dragScroll[0]) < 1) {
								dragScroll[0] = 0;
							}

							dragScroll[0] /= cfg.vw.dragScroll;
						}

						if (dragScroll[1]) {
							if (Math.abs(dragScroll[1]) < 1) {
								dragScroll[1] = 0;
							}

							dragScroll[1] /= cfg.vw.dragScroll;
						}

						var atRight = root.scrollWidth - win.scrollX === root.clientWidth,
							atBottom = root.scrollHeight - win.scrollY === root.clientHeight;

						if (!(dragScroll[0] && dragScroll[1]) || (!win.scrollY && !win.scrollX) || (!win.scrollY && atRight) || (atBottom && !win.scrollX) || (atBottom && atRight)) {
							stopScroll();
						}
					};
				}

				var handle_mDown = function(e) {
					if (e.button === 1 || e.ctrlKey || e.altKey) { return; }

					if ((e.button === 0 && cfg.vw.dam < 4) || e.button === 2) {
						if (cfg.vw.pixelmove) {
							win.onmousemove = onmove;
						}
						else {
							win.onmousemove = function () {if (progress) { clearTimeout(progress); progress = null; } win.onmousemove = null; };
						}

						if (e.button === 2) {
							sX = true;
						}
						else {
							e.preventDefault();
							sX = e.screenX;
							sY = e.screenY;
						}
					}

					if (!cfg.vw.mDownDelay) {
						return;
					}

					// for fine move and free zoom
					if (e.shiftKey || fZoom === 0) {
						cancelAction = true;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;
							contextmenu(e.clientX, e.clientY);
						}
						else {
							fZoom = {stage: 0, cX: e.clientX, cY: e.clientY};

							if (win.onmousemove === null) {
								win.onmousemove = onmove;
							}
						}
					}

					// is dragScrolling
					if (progress) {
						stopScroll && stopScroll(false, true);

						if (e.button === 0) {
							return;
						}
					}

					if (e.shiftKey) { return; }

					progress = setTimeout(function () {
						cancelAction = true;
						progress = null;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;

							try { if (img.src != win.top.location.href) { oex.postMessage({'cmd': 'open', 'url': img.src, nf: false}); return; } } catch (ex) {}

							contextmenu(e.clientX, e.clientY);
							return;
						}

						var x, y, tmpsize;

						if (cfg.vw.dam === 2 || img.width === win.innerWidth) {
							tmpsize = img.width;

							img.resize(3);

							x = e.offsetX * img.width / tmpsize - win.innerWidth / 2;
							y = 0;
						}
						else {
							tmpsize = img.height;

							img.resize(2);

							x = 0;
							y = e.offsetY * img.height / tmpsize - win.innerHeight / 2;
						}

						win.scrollTo(x, y);
					}, cfg.vw.mDownDelay);
				};

				img.addEventListener('mousedown', handle_mDown, false);

				doc.addEventListener('mouseup', function(e) {
					if (hLayer && hLayer.style.display == 'block' && !fZoom) {
						if (e.target == hLayer || (e.target.nodeName.toUpperCase() == 'A' && !e.shiftKey)) { hLayer.style.display = 'none'; }
						return;
					}

					if (e.button !== 0) { return; }

					if (cfg.vw.dam < 4) {
						win.onmousemove = null;

						if (fZoom) {
							hLayer.style.display = 'none';
							var nimgw, nimgh,
							w = fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10) - parseInt(hLayer.style.borderLeftWidth, 10),
							h = fZoom.hH - parseInt(hLayer.style.borderTopWidth, 10) - parseInt(hLayer.style.borderBottomWidth, 10),
							scrollbars = cfg.vw.hideSB ? 0 : 17, // not always 17
							winW = win.innerWidth - scrollbars,
							winH = win.innerHeight - scrollbars;

							var fitW = winW < w * winH / h;

							fitW = e.ctrlKey ? !fitW : fitW;

							if (fitW) {
								nimgw = img.width * winW / w;
								nimgh = nimgw * img.height / img.width;
							}
							else {
								nimgh = img.height * winH / h;
								nimgw = nimgh * img.width / img.height;
							}

							// not needed in Opera 12
							if (nimgw > MAXSIZE) {
								nimgw = MAXSIZE;
								nimgh = img.height * MAXSIZE / img.width;
							}

							if (nimgh > MAXSIZE) {
								nimgw = img.width * MAXSIZE / img.height;
								nimgh = MAXSIZE;
							}

							var cx = (win.scrollX + parseInt(hLayer.style.borderLeftWidth, 10) + w / 2) * nimgw / img.width - win.innerWidth / 2 - scrollbars;
							var cy = (win.scrollY + parseInt(hLayer.style.borderTopWidth, 10) + h / 2) * nimgh / img.height - win.innerHeight / 2 - scrollbars;

							img.resize(-1, nimgw + 'px', nimgh + 'px');

							win.scrollTo(cx, cy);

							fZoom = null;
							cancelAction = false;
							hLayer.innerText = '';
						}
						else if (dragScroll.length === 3) {
							var x = dragScroll[0][0] - dragScroll[2][0], y = dragScroll[0][1] - dragScroll[2][1];

							if ((Date.now() - img.dragScrollTime) > 100) { return; }

							//x = x < 0 ? Math.max(-1e3, x) : Math.min(1e3, x);
							//y = y < 0 ? Math.max(-1e3, y) : Math.min(1e3, y);

							if (x || y) {
								dragScroll = [x, y];
								progress = setInterval(scroll, 0xF);
								doc.addEventListener('mousewheel', stopScroll, false);
							}
						}
					}
				}, false);

				img.addEventListener('click', function(e) {
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction) { cancelAction = false; return; }

					if (e.button !== 0) { return; }

					if (cfg.vw.dam < 2 && noFit.real) {
						if (cfg.vw.dam === -1) { this.resize(0); }
						else if (win.innerWidth < this.naturalWidth * win.innerHeight / this.naturalHeight) { this.resize(2); }
						else { this.resize(3); }
					}
					else if (cfg.vw.dam === 1 || noFit.cur) {
						if (this.naturalWidth === this.width && this.naturalHeight === this.height) { return; }

						var x, y;

						x = e.offsetX;
						y = e.offsetY;

						if (this.scale) {
							if (this.scale.h === -1) {
								x = this.width - e.offsetX;
							}

							if (this.scale.v === -1) {
								y = this.height - e.offsetY;
							}
						}

						x = x * this.naturalWidth / this.width - win.innerWidth / 2;
						y = y * this.naturalHeight / this.height - win.innerHeight / 2;

						this.resize(0);

						win.scrollTo(x, y);
					}
					else { this.resize(1); }
				}, false);

				doc.addEventListener('keypress', function(e) {
					if (e.keyCode === 43 || e.keyCode === 45) {
						e.accelerate = e.ctrlKey;
						e.keypress = true;

						if (e.keyCode === 43) {
							e.wheelDelta = 1;
						}
						else {
							e.wheelDelta = -1;
						}

						e.offsetX = root.scrollLeft + img.offsetLeft + root.clientWidth / 2;
						e.offsetY = root.scrollTop + img.offsetTop + root.clientHeight / 2;
						e.clientX = root.clientWidth / 2;
						e.clientY = root.clientHeight / 2;

						img.wheelZoom(e);
					}
				}, false);

				doc.addEventListener('keydown', function(e) {
					stopScroll();

					if ((fZoom && e.keyCode !== 27) || /(?:TEXTAREA|INPUT|SELECT)/.test(e.target.nodeName.toUpperCase())) { return; }

					if (e.ctrlKey) {
						if (e.shiftKey && ' 37 38 39 40 '.indexOf(' ' + e.keyCode + ' ') != -1) {
							var newpos,
							x = cfg.vw.pos.charAt(0),
							y = cfg.vw.pos.charAt(1);

							switch (e.keyCode) {
								case 37: --x; break;
								case 39: ++x; break;
								case 38: --y; break;
								case 40: ++y; break;
							}

							x < 0 ? x = '0' : x > 2 && (x = '2');
							y < 0 ? y = '0' : y > 2 && (y = '2');

							newpos = x + y;

							if (newpos != cfg.vw.pos) {
								cfg.vw.pos = newpos;
								img.setPos();
							}
						}

						return;
					}

					switch (e.keyCode) {
						case cfg.tools['key_modeAuto'] : img.resize(0); break;
						case cfg.tools['key_modeFit']: img.resize(1); break;
						case cfg.tools['key_modeFitW']: img.resize(2); break;
						case cfg.tools['key_modeFitH']: img.resize(3); break;

						case 53: img.resize(4); break;

						case cfg.tools['key_customSize'] : img.setSize(); break;

						case 27 : img.reset(); break;

						case cfg.tools['key_prefs'] : oex.postMessage({'cmd': 'open', 'url': 'options.html'}); break;

						case cfg.tools['key_rotateLeft'] : img.rotate(false, e.shiftKey); break;
						case cfg.tools['key_rotateRight'] : img.rotate(true, e.shiftKey); break;
						case cfg.tools['key_rotateCustom'] : img.rotate(); break;

						case cfg.tools['key_flipH'] : img.flip(0); break;
						case cfg.tools['key_flipV'] : img.flip(1); break;

						case cfg.tools['key_imgSearch'] : imageSearch({'url': img.src, 'nf': e.shiftKey}); break;

						case cfg.tools['key_cycle'] : img.cycle(); break;

						case cfg.tools['key_contextMenu'] : hLayer && hLayer.style.display == 'block' ? (hLayer.style.display = 'none') : contextmenu(win.innerWidth / 2 - 100, win.innerHeight / 2 - 100); break;

						case 88 : img.hScroll(true); break;

						case 68 :
							if (!win.onkeyup) {
								img.removeEventListener('mousedown', handle_mDown, false);

								win.onkeyup = function(e) {
									if (e.keyCode === 68) {
										img.addEventListener('mousedown', handle_mDown, false);
										win.onkeyup = null;
									}
								};
							}
						break;
					}
				}, false);

				img.cycle = function () {
					var n_s = cfg.vw.dam + 1;

					if (n_s === 1) { ++n_s; }
					else if (n_s > 3) { n_s = 0; }

					this.resize(n_s);
				};

				img.reset = function (keep_hLayer) {
					if (doc.readyState != 'complete') { return; }

					if (!keep_hLayer && hLayer) {
						fZoom = null;
						cancelAction = false;

						if (hLayer.style.display == 'block') {
							hLayer.innerHTML = '';
							hLayer.style.display = 'none';
							return;
						}

						doc.body.removeChild(hLayer);
						hLayer = null;
					}

					delete this.currentdeg;
					delete this.scale;
					this.style['OTransform'] = this.parentNode.style['backgroundSize'] = this.style.width = this.style.height = '';
					this.resize(0);
				};

				img.setSize = function () {
					setTimeout(function() {
						var size = prompt('(0 < x,y <= ' + MAXSIZE + ')\n' + LN('ORIG_DIMENS') + ': ' + img.naturalWidth + ' x ' + img.naturalHeight, '0');

						if (!size) { return; }

						size = size.replace(/(?:^\s+|\s+$)/g, '');

						if (/^(\d{1,5}%?)(\s+\d{1,5}%?)?$/i.test(size)) {
							size = size.split(/\s+/);

							if (cfg.vw.dam === 4) {
								if (size[0] == 0) { size[0] = 'auto'; }
								if (size[1] && size[1] == 0) { size[1] = 'auto'; }
								doc.body.style.backgroundSize = size.join(' ');
							}
							else {
								var w = '', h = '';

								if (parseInt(size[0], 10) > 0) {
									w = size[0].indexOf('%') > 0 ? size[0] : Math.min(Math.max(0, size[0]), MAXSIZE) + 'px';
								}

								if (size[1] && parseInt(size[1], 10) > 0) {
									h = size[1].indexOf('%') > 0 ? size[1] : Math.min(Math.max(0, size[1]), MAXSIZE) + 'px';
								}

								img.resize(-1, w, h);
							}
						}
						else { alert(LN('INCORRECT_VALUE')); }
					}, 1);
				};

				img.rotate = function (deg, fine) {
					setTimeout(function() {
						var rot = img.style['OTransform'].match(/rotate\((\-?\d+(?:\.\d+)?)deg\)/i);

						if (rot) { rot = rot[1]; }
						else { img.currentdeg = rot = 0; }

						if (deg === undefined && !/^\s*-?\d+(?:\.\d+)?\s*$/.test(deg = prompt('°:', rot))) {
							if (deg) { alert(LN('INCORRECT_VALUE')); }
							return;
						}

						if (deg === true) { img.currentdeg += (fine ? 10 : 90); }
						else if (deg === false) { img.currentdeg -= (fine ? 10 : 90); }
						else { img.currentdeg = deg; }

						//if (img.currentdeg !== 0 && Math.cos(img.currentdeg * 0.017453292519943295) === 1) { img.currentdeg = 0; }

						win.status = img.currentdeg + '°';

						if (typeof img.currentdeg != 'undefined') { rot = 'rotate(' + img.currentdeg + 'deg)'; }
						if (img.scale) { rot += ' scale(' + img.scale.h + ',' + img.scale.v + ')'; }
						img.style['OTransform'] = rot;
					}, 1);
				};

				img.flip = function (ori) {
					if (!this.scale) { this.scale= {h: 1, v: 1 }; }

					if (ori) { this.scale.h = -this.scale.h; }
					else { this.scale.v = -this.scale.v; }

					var flip = (!this.scale.h && !this.scale.v) ? '' : 'scale('+this.scale.h+','+this.scale.v+')';
					if (this.currentdeg) { flip='rotate('+this.currentdeg+'deg) ' + flip; }
					this.style['OTransform'] = flip;
				};

				// don't upscale large images
				if ((cfg.vw.dam === 2 && img.naturalWidth < win.innerWidth) || (cfg.vw.dam === 3 && img.naturalHeight < win.innerHeight)) {
					cfg.vw.dam = 0;
				}

				setTimeout(function () { img.resize(cfg.vw.dam); img.style.visibility = 'visible'; }, 101);
			}
			else if (++init.loop >= init.maxloop) {
				clearInterval(progress);
			}
		};

		if (img.naturalWidth && img.naturalHeight) { load(true); }
		else { progress = setInterval(load, init.wait); }

		oex.removeEventListener('message', arguments.callee, false);
	}, false);

	win.onkeypress = win.onmousedown = win.onmouseup = null;
}
else {
	var isHTML = doc instanceof win['HTMLDocument'] || (doc.documentElement && root.nodeName.toUpperCase() == 'HTML'),
		mdownstart,
		rgxNewLines = /(?:\n|\r\n?)+/g,
		rgxBgURL = /"[^"]+"/g, //g for mutlitple backgrounds
		rgxProtCheck = /^\w+:/i,
		rgxQueryHash = /[\?#].*/,
		rgxHash = /#.*/,
		rgxDomain = /^(\w+:\/\/[^\/]+)\/.*/,
		rgxPath = /(\/)[^\/]*$/,
		// http://www.opera.com/docs/specs/presto211/#graphics
		rgxObjImg = /\.(?:jp(?:e|e?g)|a?png|gif|svgz?|webp|w?bmp|cur|ico|xbm|pict|j(?:if|fif?))$/i,

	checkBG = function (match/*, p*/) {
		if (match) {
			var el_images = [], imaddr, i;

			for (i in match) {
				imaddr = match[i].slice(1, -1);

				// need this check, because Opera won't prepend the baseURI to background attribute
				if (!rgxProtCheck.test(imaddr)) {
					imaddr = doc.baseURI.replace(rgxQueryHash, '').replace((imaddr.charAt(0) == '/' && node.src.charAt(1) != '/' ? rgxDomain : rgxPath), '$1') + imaddr;
				}

				el_images.push(imaddr);
			}

			//return p && el_images.length > 0 ? {path: p, imgs: el_images} : el_images;
			return el_images.length > 0 ? el_images : null;
		}

		return null;
	},

	checkIMG = function (node) {
		var nname = node.nodeName.toUpperCase();

		if (nname == 'IMG' || (node.type == 'image' && /^(?:BUTTON|INPUT)/.test(nname)) || nname == 'EMBED') {
			return node.src;
		}
		/*else if (nname == 'CANVAS') {
			return node.toDataURL(); // security violation? why?
		}*/
		else if (nname == 'OBJECT' && node.data != ''/* && (/^image/i.test(node.type) || rgxObjImg.test(node.data))*/) {
			return node.data;
		}
		else if (nname == 'AREA') {
			var img = doc.querySelector('img[usemap="#' + node.parentNode.name + '"]');
			return img.src;
		}
		else if (nname == 'VIDEO' && node.poster != '') {
			return node.poster;
		}

		return false;
	};

	win.opera.addEventListener('BeforeEvent.mousedown', function (e) {
		if (e.event.button === 2) { mdownstart = Date.now(); }
	}, false);

	win.opera.addEventListener('BeforeEvent.contextmenu', function (ev) {
		var e = ev.event;

		if (e.button !== 2) { return; }

		var i, img, el, nosvg = true, bgImages = [], elapsed = (Date.now() - mdownstart) >= 300;
		mdownstart = 0;

		if (e.ctrlKey && e.altKey) {
			ev.preventDefault();
			e.preventDefault();

			if (elapsed) {
				oex.postMessage({'cmd': 'favi', nf: e.shiftKey});
			}
			else {
				(img = checkIMG(e.target)) && imageSearch({'url': img, 'nf': e.shiftKey});
			}

			return;
		}

		if (e.ctrlKey && elapsed) {
			el = e.target;
			i = 13;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(win.getComputedStyle(el).backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (i === 9) {
					el = el.previousElementSibling || el.parentNode;
				}
				else {
					if (el.childElementCount) {
						el = el.lastElementChild;
					}
					else if (el.previousElementSibling) {
						el = el.previousElementSibling;
					}
					else if (el.parentNode) {
						el = el.parentNode.previousElementSibling;
					}
					else {
						el = false;
					}
				}
			}

			// need check
			el = e.target.childElementCount ? e.target.firstElementChild : (e.target.nextElementSibling || e.target.parentNode.nextElementSibling);
			i = 13;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(win.getComputedStyle(el).backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (el.childElementCount) {
					el = el.firstElementChild;
				}
				else if (el.nextElementSibling) {
					el = el.nextElementSibling;
				}
				// while el.parentNode.nextElementSibling or not
				else if (el.parentNode && el.parentNode.nextElementSibling) {
					el = el.parentNode.nextElementSibling;
				}
				else {
					el = false;
				}
			}
		}

		if ((e.altKey || elapsed) && !(e.altKey && elapsed)) {
			if (e.target.document instanceof win['SVGDocument'] || /^\[object SVG/.test(e.target.toString())) {
				nosvg = false;
				//if (e.target.document.URL != win.top.location.href) {
				if (win != win.top) {
					bgImages.push(win.location.href);
				}
			}
			else {
				img = checkIMG(e.target);
				img && bgImages.push(img);
			}
		}

		if ((e.ctrlKey || elapsed) && !(e.ctrlKey && elapsed) && nosvg) {
			el = e.target;

			if (el.nodeName.toUpperCase() == 'HTML') {
				img = checkBG(win.getComputedStyle(el).backgroundImage.match(rgxBgURL) || win.getComputedStyle(doc.querySelector('body')).backgroundImage.match(rgxBgURL)/*, 'html>body'*/);
				img && (bgImages = bgImages.concat(img));
			}
			else {
				var imgList, comp_style;//, path = '';

				while (el && el.nodeName != '#document') {
					//path = path ? el.nodeName + '>' + path : el.nodeName;
					comp_style = win.getComputedStyle(el);
					match = comp_style.backgroundImage.match(rgxBgURL);

					if (el.nodeName.toUpperCase() == 'UL') {
						var f = comp_style.listStyleImage.match(rgxBgURL);
						if (f) {
							if (match) { match.push(f); }
							else { match = f; }
						}
					}

					imgList = checkBG(match/*, path*/);
					imgList && (bgImages = bgImages.concat(imgList));

					el = el.parentNode;
				}
			}
		}

		if (bgImages && bgImages.length > 0) {
			ev.preventDefault();
			e.preventDefault();

			if (!(e.ctrlKey && e.altKey) && !(e.ctrlKey && elapsed)) {
				oex.postMessage({'cmd': 'open', 'url': bgImages[0], nf: e.shiftKey});
			}
			else {
				if (bgImages.length > 1) {
					var a = [], l = bgImages.length, j;

					for (i = 0; i < l; ++i) {
						for (j = i + 1; j < l; ++j) {
							if (bgImages[i] == bgImages[j]) {
								j = ++i;
							}
						}

						a.push(bgImages[i]);
					}

					bgImages = a;
				}

				for (i = 0; i < bgImages.length; ++i) {
					oex.postMessage({'cmd': 'open', 'url': bgImages[i], nf: e.shiftKey});
				}
			}
		}
	}, false);

	if (!isHTML) { return; }
}

var imageSearch = function (sf) {
	if ((!sf.url && !sf.name && !sf.url) || sf.url && !/^https?/.test(sf.url)) { alert(LN('URL is not supported!')); return; }

	var i = 0, hosts = cfg.tools['imgSearchHosts'], go = [];

	for (; i < hosts.length; ++i) {
		if (sf.host === i || sf.host === -1 || (sf.host === undefined && hosts[i][0][0] == '+')) {
			go.push(hosts[i][1].replace('%url', encodeURIComponent(sf.url)));
		}
	}

	oex.postMessage({'cmd': 'open', 'url': go, 'nf': !!sf.nf});
};

var PVI = {
	PrevDIV: null,
	PrevOBJ: null,
	helper_div: null,
	target: null,
	img: null,
	imageStack: {},
	collectxy: false,
	xy: [0, 0],
	timers: {imload: null, preview: null},
	resolving: {counter: 0, nodes: {}},
	anim: {},
	bdy: null,
	create: function () {
		if (PVI.PrevDIV) { return; }

		root || (root = doc.documentElement);
		PVI.bdy = doc.querySelector(':root>body');
		PVI.PrevDIV = doc.createElement('div');
		PVI.PrevOBJ = doc.createElement('object');
		PVI.PrevDIV.imagus_ = PVI.PrevOBJ.imagus_ = true;

		var bg = '', div_caption;

		if (cfg.hz['background']) {
			if (cfg.hz['background'] == 'cb') {
				bg = ';background-color:rgba(0,0,0,0);background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7)';
			}
			else if (/(?:http|-o-)/i.test(cfg.hz['background'])) { bg = ';background-color:rgba(0,0,0,0);background-image:' + cfg.hz['background']; }
			else { bg = ';background-color:' + cfg.hz['background']; }

			bg += ';background-clip:padding-box';
		}

		PVI.PrevDIV.style.cssText = 'position:fixed;z-index:2147483646;left:auto;top:auto;right:auto;bottom:auto;width:auto;height:auto;padding:0;font-size:9pt;font-family:Verdana;color:#000' + bg + (cfg.hz['shadow'] ? ';box-shadow:' + cfg.hz['shadow'] : '') + (cfg.hz['border'] ? ';border:' + cfg.hz['border'] : '') + (cfg.hz['fade'] ? ';opacity:0' : '');
		PVI.PrevOBJ.style.cssText = 'display:block;width:auto;height:auto;margin:0' + (cfg.hz['border'] ? ';border:1px solid #bbb' : '');
		PVI.PrevOBJ.type = 'image/jpeg';
		//PVI.PrevOBJ.data = 'data:image/gif,';
		PVI.PrevDIV.appendChild(PVI.PrevOBJ);
		//'<div style="position:absolute;top:0;right:0;background-color:rgba(0,0,0,0.2);color:#fff">' +
		//'<div>rotate left right</div><div>flipv flipH</div><div>upload</div><div>zoom-zoom</div></div>' +
		if (cfg.hz['caption']) {
			div_caption = doc.createElement('div');
			div_caption.imagus_cache = div_caption.imagus_ = true;
			div_caption.style.cssText = (cfg.hz['caption'] === 1 ? 'top' : 'bottom') + ':-1em;left:5px;position:absolute;height:auto;border:0;margin-right:5px;white-space:nowrap;background-color:#fff;padding:0 5px;border-radius:4px;color:#000';
			PVI.PrevDIV.appendChild(div_caption);
		}

		PVI.PrevDIV.outsize = 2 * (cfg.hz['margin'] + (cfg.hz['border'] ? parseInt(PVI.PrevDIV.style.borderWidth, 10) + 1 : 0));
		PVI.anim.container = [];

		if (cfg.hz['fade']) {
			PVI.anim.container.push('opacity ' + cfg.hz['fade'] + 'ms');
			PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && this.style.display == 'block' && this.style.opacity == '0') {
					PVI.reset();
				}
			}, false);
		}

		if (cfg.hz['position']) {
			PVI.anim.container.push(['top', 'right', 'bottom', 'left'].join(' ' + cfg.hz['position'] + 'ms, ') + ' ' + cfg.hz['position'] + 'ms');

			!cfg.hz['fade'] && PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && this.style.display == 'block' && (parseInt(this.style.left, 10) < 0 || parseInt(this.style.right, 10) < 0)) {
					PVI.reset();
				}
			}, false);
		}

		if (cfg.hz['sizing']) {
			PVI.PrevOBJ.style['OTransition'] = PVI.anim.obj = 'max-width ' + cfg.hz['sizing'] + 'ms, max-height ' + cfg.hz['sizing'] + 'ms';
			PVI.PrevOBJ.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && PVI.PrevDIV.style.display == 'block' && this.style.maxWidth == '0px') {
					PVI.reset();
				}
			}, false);
		}

		if (PVI.anim.container.length) { PVI.PrevDIV.style['OTransition'] = PVI.anim.container = PVI.anim.container.join(', '); }

		root.appendChild(PVI.PrevDIV);

		PVI.helper_div = doc.createElement('div');
		PVI.helper_div.style.cssText = 'position:absolute;top:0;z-index:-666;height:100%;width:0;border:0;padding:0;margin:0;overflow:hidden';
		root.appendChild(PVI.helper_div);

		PVI.reset(true);
	},
	resolve: function (URL, res) {
		if (win.location.href.replace(rgxHash, '') == URL.replace(rgxHash, '')) { return false; }

		clearTimeout(PVI.timers.imload);

		PVI.timers.imload = setTimeout(function () {
			PVI.resolving.nodes[++PVI.resolving.counter] = PVI.target;
			oex.postMessage({'cmd': 'resolve', 'url': URL, 'find': res, 'id': PVI.resolving.counter});
		}, cfg.hz['hoverTime']);

		return true;
	},
	find: function (tt) {
		var i = 0, n = tt || PVI.target, ret = false, sn, imgSRC, imgBG, found;

		if (n.href && n.childElementCount > 0) { return false; }

		if (n.src) { n.imagus_img_src = imgSRC = n.src; }
		if ((imgBG = win.getComputedStyle(n).backgroundImage) == 'none') { imgBG = false; }
		else { imgBG = (n.clientWidth < window.innerWidth / 2.3 && n.clientHeight < window.innerHeight / 2) && (imgBG = imgBG.match(rgxBgURL)) ? imgBG[0].slice(1, -1) : false; }

		do {
			if (n.href) {
				if (!tt) {
					if (!PVI.target.imagus_link_node) { PVI.target.imagus_link_node = n; }
					PVI.target.imagus_link_url = n.href;
				}

				if ((!isRaster && win.location.href.replace(rgxHash, '') == n.href.replace(rgxHash, '')) || (!tt && PVI.target.src && n.href == PVI.target.src)) { break; }

				sieveloop:
				for (sn in cfg.sieve) {
					if (cfg.sieve[sn].link && cfg.sieve[sn].link.test(n[(cfg.sieve[sn].attr && n[cfg.sieve[sn].attr] ? cfg.sieve[sn].attr : 'href')])) {
						if (cfg.sieve[sn].useimg && cfg.sieve[sn].img) {
							if ((imgSRC && cfg.sieve[sn].img.test(imgSRC)) || (imgBG && cfg.sieve[sn].img.test(imgBG))) {
								found = sn;
								break;
							}
						}

						if (cfg.sieve[sn].res && PVI.resolve((cfg.sieve[sn].url ? n.href.replace(cfg.sieve[sn].link, cfg.sieve[sn].url) : n.href), cfg.sieve[sn].res)) {
							ret = null;
							break;
						}

						if (Array.isArray(cfg.sieve[sn].to)) {
							ret = [];

							for (var toi = 0; toi < cfg.sieve[sn].to.length; ++toi) {
								ret.push(n.href.replace(cfg.sieve[sn].link, cfg.sieve[sn].to[toi]));

								if (ret[toi] == n.href) {
									ret.pop();
									if (!PVI.length) { tt = true; break sieveloop; }
									else if (PVI.length === 1) { ret = ret[0]; }
									break;
								}

								cfg.sieve[sn].decode && (ret[toi] = decodeURIComponent(decodeURIComponent(ret[toi])));
							}
						}
						else if (cfg.sieve[sn].to) {
							ret = n.href.replace(cfg.sieve[sn].link, cfg.sieve[sn].to);
							cfg.sieve[sn].decode && (ret = decodeURIComponent(decodeURIComponent(ret)));
						}
						else {
							ret = n.href;
						}

						if (cfg.sieve[sn].loop && typeof ret == 'string') {
							var tmp_el = doc.createElement('node');
							tmp_el.href = ret;
							ret = PVI.find(tmp_el);
						}

						break;
					}
				}

				break;
			}
		} while (++i < 5 && (n = n.parentNode));

		if (!tt) {
			if (!ret && ret !== null) {
				if (imgSRC || imgBG) {
					var f_src = true, toi, tmp_el;

					sieveloop:
					for (sn in cfg.sieve) {
						if (found || (cfg.sieve[sn].img && ((f_src = cfg.sieve[sn].img.test(imgSRC)) || cfg.sieve[sn].img.test(imgBG)))) {
							imgSRC = (f_src && imgSRC ? imgSRC : imgBG);

							if (found) { sn = found; }

							if (!cfg.sieve[sn].to && cfg.sieve[sn].res && cfg.sieve[sn].url && PVI.resolve(imgSRC.replace(cfg.sieve[sn].img, cfg.sieve[sn].url), cfg.sieve[sn].res)) {
								ret = null;
							}
							else {
								if (Array.isArray(cfg.sieve[sn].to)) {
									ret = [];

									for (toi = 0; toi < cfg.sieve[sn].to.length; ++toi) {
										ret.push(imgSRC.replace(cfg.sieve[sn].img, cfg.sieve[sn].to[toi]));

										if (ret[toi] == imgSRC) {
											ret.pop();
											if (!PVI.length) { tt = true; break sieveloop; }
											else if (PVI.length === 1) { ret = ret[0]; }
											break;
										}

										cfg.sieve[sn].decode && (ret[toi] = decodeURIComponent(ret[toi]));
									}
								}
								else if (cfg.sieve[sn].to) {
									ret = imgSRC.replace(cfg.sieve[sn].img, cfg.sieve[sn].to);
									cfg.sieve[sn].decode && (ret = decodeURIComponent(ret));
								}
								else {
									ret = imgSRC;
								}
							}

							if (cfg.sieve[sn].loop && !cfg.sieve[sn].link && typeof ret == 'string') {
								tmp_el = doc.createElement('node');
								tmp_el.href = ret;
								ret = PVI.find(tmp_el);
							}

							found = true;
							break;
						}
					}
				}
			}

			if (PVI.target.src) {
				if (typeof ret == 'string' && ret == PVI.target.src) { ret = false; }

				if (cfg.hz['zoomResized']) {
					if (ret) {
						if (found === true) {
							PVI.target.imagus_thumb = true;
						}
					}
					else if (ret !== null && (PVI.target.naturalWidth - cfg.hz['zoomResized'] > PVI.target.clientWidth || PVI.target.naturalHeight - cfg.hz['zoomResized'] > PVI.target.clientHeight) && PVI.target.clientWidth <= win.innerWidth && PVI.target.clientHeight <= win.innerHeight) {
						ret = PVI.target.src;
					}
				}
			}

			// it's too rare, not worth it
			//ret && (ret = ret.replace(/#/g, '%23'));
		}

		if (tt === true) { ret = false; }
		else if (ret || ret === null) {
			if (!tt) {
				n = PVI.target;

				do {
					if (n.title !== '') {
						if (cfg.hz['caption'] && !PVI.target.imagus_title) {
							PVI.target.imagus_title = n.title;
						}

						n.removeAttribute('title');
						n.title = '';
					}
				} while ((n = n.parentNode) && n.nodeName.toUpperCase() != 'HTML');

				if (cfg.hz['caption'] && !PVI.target.imagus_title && PVI.target.alt) {
					PVI.create();
					PVI.helper_div.innerHTML = PVI.target.alt.replace(rgxNewLines, ' ').replace(/</g, '&lt;');
					PVI.target.imagus_title = PVI.helper_div.innerText;
					PVI.helper_div.innerText = '';
				}

				if (typeof ret == 'string' && rgxIsSVG.test(ret)) {
					PVI.target.imagus_SVG = true;
				}
			}
		}

		return ret;
	},
	show: function (msg) {
		!cfg.hz['move'] && (PVI.collectxy = false);

		if (!msg && PVI.iFrame) {
			if (typeof PVI.target.imagus_cache == 'string') { oex.postMessage({'cmd': 'from_frame', 'img': PVI.target.imagus_cache, 'svg': !!PVI.target.imagus_SVG}); }
			return;
		}

		if (PVI.hiding) {
			if (cfg.hz['waitHide']) { return; }

			PVI.hiding = false;
		}
		else if (PVI.PrevDIV.style.display != 'block') {
			if (!msg) { PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = '0'; }

			PVI.PrevDIV.style.display = 'block';
			cfg.hz['fade'] && (PVI.PrevDIV.style.opacity = '1');
			cfg.hz['position'] && typeof PVI.target.imagus_cache == 'string' && PVI.show(true);
		}

		if (typeof msg == 'string') {
			PVI.PrevOBJ.innerText = msg;

			if (cfg.hz['sizing']) {
				PVI.PrevOBJ.style.maxWidth = Math.max(msg.length * 8, PVI.PrevOBJ.clientWidth) + 'px';
				PVI.PrevOBJ.style.maxHeight = Math.max(20, PVI.PrevOBJ.clientHeight) + 'px';
			}
		}

		var winW = Math.max(PVI.bdy.clientWidth, root.clientWidth),
				winH,
				left, top, bottom, right;

		(winW > win.innerWidth) && (winW = win.innerWidth);
		winH = PVI.helper_div.clientHeight;

		var rSide = winW - PVI.xy[0], bSide = winH - PVI.xy[1];

		if (PVI.xy[0] < rSide) {
			left = PVI.xy[0];
			PVI.PrevDIV.style.right = 'auto';
		}
		else {
			right = rSide;
			PVI.PrevDIV.style.left = 'auto';
		}

		if (PVI.xy[1] < bSide) {
			top = PVI.xy[1];
			PVI.PrevDIV.style.bottom = 'auto';
		}
		else {
			bottom = bSide;
			PVI.PrevDIV.style.top = 'auto';
		}

		if (!msg && typeof PVI.target.imagus_cache == 'string') {
			var ow = PVI.imageStack[PVI.target.imagus_cache][0], oh = PVI.imageStack[PVI.target.imagus_cache][1],
					w = ow + PVI.PrevDIV.outsize,
					h = oh + PVI.PrevDIV.outsize,
					vAreaFill, hAreaFill,
					ratio = ow / oh,
					fakeRatio = w / h;

			if (cfg.hz['placement'] === 2) {
				PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';

				w = Math.min(w, winW);
				h = Math.min(h, winH);

				if (w / h > ow / oh) { w = ratio * h; }
				else { h = w / ratio; }

				left = (winW - w) / 2;
				top = (winH - h) / 2;
				right = bottom = undefined;
			}
			else {
				w = Math.min(w, winW);
				h = Math.min(h, winH);

				if (top) { hAreaFill = bSide; }
				else { hAreaFill = PVI.xy[1]; }

				hAreaFill = ratio > winW / hAreaFill ? winW : hAreaFill * ratio;

				if (left) { vAreaFill = rSide; }
				else { vAreaFill = PVI.xy[0]; }

				vAreaFill = ratio > vAreaFill / winH ? vAreaFill : winH * ratio;

				if (left && top) {
					//PVI.PrevDIV.style.top = PVI.PrevDIV.style.left = 'auto';
					//top = left = undefined; bottom = right = 0;
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, bSide);
						if (cfg.hz['placement'] === 1) { left = Math.max(0, PVI.xy[0] - fakeRatio * h / 2); }
						else { left -= Math.max(0, w - rSide); }
					}
					else {
						w = Math.min(w, rSide);
						if (cfg.hz['placement'] === 1) { top = Math.max(0, PVI.xy[1] - w / fakeRatio / 2); }
						else { top -= Math.max(0, h - bSide); }
					}
				}

				if (right && top) {
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, bSide);
						if (cfg.hz['placement'] === 1) { right = Math.max(0, rSide - (fakeRatio * h) / 2); }
						else { right -= Math.max(0, w - PVI.xy[0]); }
					}
					else {
						w = Math.min(w, PVI.xy[0]);
						if (cfg.hz['placement'] === 1) { top = Math.max(0, PVI.xy[1] - w / fakeRatio / 2); }
						else { top -= Math.max(0, h - bSide); }
					}
				}

				if (left && bottom) {
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, PVI.xy[1]);
						if (cfg.hz['placement'] === 1) { left = Math.max(0, PVI.xy[0] - fakeRatio * h / 2); }
						else { left -= Math.max(0, w - rSide); }
					}
					else {
						w = Math.min(w, rSide);
						if (cfg.hz['placement'] === 1) { bottom = Math.max(0, bSide - w / fakeRatio / 2); }
						else { bottom -= Math.max(0, h - PVI.xy[1]); }
					}
				}

				if (right && bottom) {
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, PVI.xy[1]);
						if (cfg.hz['placement'] === 1) { right = Math.max(0, rSide - fakeRatio * h / 2); }
						else { right -= Math.max(0, w - PVI.xy[0]); }
					}
					else {
						w = Math.min(w, PVI.xy[0]);
						if (cfg.hz['placement'] === 1) { bottom = Math.max(0, bSide - w / fakeRatio / 2); }
						else { bottom -= Math.max(0, h - PVI.xy[1]); }
					}
				}
			}
		}

		top === undefined || (PVI.PrevDIV.style.top = (top + cfg.hz['margin']) + 'px');
		left === undefined || (PVI.PrevDIV.style.left = (left + cfg.hz['margin']) + 'px');
		bottom === undefined || (PVI.PrevDIV.style.bottom = (bottom + cfg.hz['margin']) + 'px');
		right === undefined || (PVI.PrevDIV.style.right = (right + cfg.hz['margin']) + 'px');

		if (!msg && typeof PVI.target.imagus_cache == 'string') {
			if (PVI.target.imagus_SVG) {
				PVI.PrevOBJ.style.OObjectFit = 'contain';

				if (w / h > ow / oh) { w = ratio * h; }
				else { h = w / ratio; }

				PVI.PrevOBJ.style.width = (w - PVI.PrevDIV.outsize) + 'px';
				PVI.PrevOBJ.style.height = (h - PVI.PrevDIV.outsize) + 'px';
			}

			PVI.PrevOBJ.style.maxWidth = (w - PVI.PrevDIV.outsize) + 'px !important';
			PVI.PrevOBJ.style.maxHeight = (h - PVI.PrevDIV.outsize) + 'px !important';

			cfg.hz['caption'] && (PVI.PrevDIV.lastChild.innerText = PVI.target.imagus_title || '');// + ' ' + PVI.PrevOBJ.clientWidth + 'x' + PVI.PrevOBJ.clientHeight;
		}
	},
	hide: function (ev) {
		if (!ev.force) {
			if (!PVI.fireHide || (ev.toElement || {}).imagus_ || ((ev.fromElement || {}).imagus_ && ev.toElement == PVI.target)) {
				return;
			}
		}

		PVI.fireHide = !PVI.fireHide;

		cfg.hz['outline'] && ((ev.target.origOutline === undefined) || (ev.target.style.outline = ev.target.origOutline));

		clearInterval(PVI.timers.preview);
		clearInterval(PVI.timers.imload);

		if (PVI.fullZoom || (cfg.hz['deactivate'] && ev[cfg.hz['actTrigger'] + 'Key'])) { return; }

		PVI.collectxy = false;

		if (PVI.iFrame) {
			if (typeof ev.fromElement.imagus_cache == 'string') {
				oex.postMessage({'cmd': 'from_frame', 'hide': true});
			}
		}
		else if (!PVI.fullZoom) {
			win.removeEventListener('mousemove', PVI.m_move, false);
		}

		if (!PVI.hiding && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
			if (PVI.PrevDIV.childElementCount > 1) {
				if (PVI.PrevDIV.lastChild.nodeName.toUpperCase() == 'OBJECT') {
					PVI.PrevDIV.removeChild(PVI.PrevDIV.lastChild);
				}
				else if (cfg.hz['caption']) {
					PVI.PrevDIV.lastChild.innerText = '';
				}
			}

			PVI.hiding = true;
			var onlypos = !cfg.hz['sizing'] && !cfg.hz['fade'];

			if (onlypos || (cfg.hz['position'] && cfg.hz['follow'])) {
				if (onlypos) {
					var winW = Math.max(PVI.bdy.clientWidth, root.clientWidth);
					(winW > win.innerWidth) && (winW = win.innerWidth);
				}

				if (!onlypos) {
					if (PVI.PrevDIV.style.top != 'auto') {
						PVI.PrevDIV.style.top = ev.clientY + 'px';
					}
					else if (PVI.PrevDIV.style.bottom != 'auto') {
						PVI.PrevDIV.style.bottom = (win.innerHeight - ev.clientY) + 'px';
					}
				}

				if (PVI.PrevDIV.style.right != 'auto') {
					PVI.PrevDIV.style.right = (onlypos ? - ev.clientX - 30: PVI.bdy.clientWidth - ev.clientX) + 'px';
				}
				else if (PVI.PrevDIV.style.left != 'auto') {
					PVI.PrevDIV.style.left = (onlypos ? - winW + ev.clientX - 30 : ev.clientX) + 'px';
				}
			}

			if (cfg.hz['sizing']) {
				PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = PVI.PrevOBJ.data ? '0' : 'none';
			}

			cfg.hz['fade'] && (PVI.PrevDIV.style.opacity = '0');
			onlypos && !cfg.hz['position'] && PVI.reset();
		}
	},
	set: function (src) {
		clearInterval(PVI.timers.imload);
		PVI.create();

		if (Array.isArray(src)) {
			var src_arr_left = src.length > 1 ? src.slice(1) : false;
			src = src[0];
		}

		if (PVI.target.imagus_SVG || rgxIsSVG.test(src)) {
			PVI.target.imagus_SVG || (PVI.target.imagus_SVG = true);

			if (PVI.PrevDIV.childElementCount > 1 && PVI.PrevDIV.lastChild.nodeName.toUpperCase() == 'OBJECT') {
				PVI.PrevDIV.lastChild.data = src + '#IMAGUS_SVG_GET';
			}
			else {
				var svg_obj = doc.createElement('object');
				svg_obj.style.cssText = 'width:0;height:0';
				svg_obj.data = src + '#IMAGUS_SVG_GET';
				PVI.PrevDIV.appendChild(svg_obj);
			}

			clearInterval(PVI.timers.imload);
			PVI.timers.imload = setTimeout(function () {
				PVI.PrevOBJ.innerText = 'Timmo!';

				if (PVI.PrevDIV.childElementCount > 1 && PVI.PrevDIV.lastChild.nodeName.toUpperCase() == 'OBJECT') {
					svg_obj.date = '';
					PVI.PrevDIV.removeChild(svg_obj);
				}
			}, cfg.hz['timeout']);

			PVI.show('Loddig SVG...');
			return;
		}

		PVI.img = new Image();
		PVI.img.onerror = function (x) {
			clearInterval(PVI.timers.imload);

			if (x !== true) {
				PVI.target.imagus_cache_resolved = src;

				if (src_arr_left) {
					PVI.set(src_arr_left);
					throw null;
				}
			}

			PVI.PrevOBJ.innerText = (x === true ? 'Timmo!' : 'Erray!');

			throw null;
		};

		PVI.img.src = src;

// something isn't good, it loads the page between multiple rule replacements
//alert(PVI.PrevOBJ.data)

		if (PVI.img.naturalWidth) { PVI.assign_src(src); return; }

		PVI.show('Loddig...');

		var startTime = Date.now();

		PVI.timers.imload = setInterval(function () {
			if (PVI.img.naturalWidth && PVI.img.naturalHeight) {
				clearInterval(PVI.timers.imload);

				PVI.assign_src(src, true);
				return;
			}

			if (Date.now() - startTime >= cfg.hz['timeout']) { PVI.img.onerror(true); }
		}, 500);
	},
	assign_src: function (src, hide) {
		PVI.target.imagus_cache_resolved = true;

		if (PVI.target.imagus_thumb && (PVI.img.naturalWidth - cfg.hz['zoomResized'] < PVI.target.width && PVI.img.naturalHeight - cfg.hz['zoomResized'] < PVI.target.clientHeight)) {
			hide && PVI.reset();
			delete PVI.target.imagus_thumb;
			PVI.target.imagus_cache = true;
			cfg.hz['outline'] && (PVI.target.style.outline = '1px solid purple');
			return;
		}

		PVI.PrevOBJ.data = PVI.target.imagus_cache = src;
		PVI.imageStack[src] = [PVI.img.naturalWidth, PVI.img.naturalHeight];
		PVI.show();
	},
	reset: function (first) {
		if (!PVI.PrevDIV) { return; }

		PVI.PrevDIV.style.display = 'none';

		if (PVI.PrevOBJ.style.width != 'auto') { PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto'; }

		if (cfg.hz['sizing']) {
			//PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = 'none';
			PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = '0';
		}

		PVI.PrevDIV.style.top = PVI.PrevDIV.style.bottom = PVI.PrevDIV.style.right = PVI.PrevDIV.style.left = 'auto';
		cfg.hz['fade'] && (PVI.PrevDIV.style.opacity = '0');
		delete PVI.PrevOBJ.data;
		PVI.PrevOBJ.innerText = '';
		cfg.hz['caption'] && (PVI.PrevDIV.lastChild.innerText = '');
		PVI.hiding = false;

		if ((PVI.target || {}).imagus_SVG) { PVI.PrevOBJ.style.OObjectFit = 'auto'; }

		if (PVI.fullZoom) {
			PVI.fullZoom = false;
			PVI.PrevDIV.style['OTransition'] = PVI.anim.container;
			PVI.PrevOBJ.style['OTransition'] = PVI.anim.obj;
			PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto';
		}

		if (!first) {
			win.removeEventListener('keypress', PVI.key_action, false);
		}
	},
	key_action: function (ev) {
		var keyCode;

		if (PVI.target && PVI.PrevDIV.style.display == 'block') {
			if (!ev.ctrlKey && !ev.altKey && !ev.metaKey) { ev.preventDefault(); }

			keyCode = String.fromCharCode(ev.keyCode).toUpperCase().charCodeAt(0);

			if (keyCode === 43 || keyCode === 45) { // - +
				PVI.PrevOBJ.style.width = Math.max(10, PVI.PrevOBJ.clientWidth * (keyCode === 43 ? 1.2 : 0.8)) + 'px';
				// TODO: left top
				//PVI.PrevDIV.style.top = (parseInt(PVI.PrevDIV.style.top) + (parseInt(PVI.PrevDIV.style.top) * (keyCode === 43 ? -0.2 : 0.2))) + 'px';
				//PVI.PrevDIV.style.left = (parseInt(PVI.PrevDIV.style.left) + (parseInt(PVI.PrevDIV.style.left) * (keyCode === 43 ? -0.2 : 0.2))) + 'px';
			}
			else if (keyCode === 42) { // *
				PVI.PrevOBJ.style.width = 'auto';
			}
			else if (keyCode === 79) { // Open
				if (typeof PVI.target.imagus_cache == 'string' || typeof PVI.target.imagus_cache_resolved == 'string') {
					oex.postMessage({'cmd': 'open', 'url': (PVI.PrevOBJ.data || PVI.target.imagus_cache_resolved).replace(rgxHash, ''), nf: ev.shiftKey});
					if (!ev.shiftKey) { PVI.fastHide(); }
				}
			}
			else if (keyCode === 67) {
				if (ev.shiftKey) { PVI.PrevDIV.lastChild.style.display = win.getComputedStyle(PVI.PrevDIV.lastChild).display != 'block' ? 'block' : 'none'; }
				else {
					if (PVI.PrevDIV.lastChild.style.whiteSpace == 'nowrap') {
						PVI.PrevDIV.lastChild.style.whiteSpace = 'normal';
						PVI.PrevDIV.lastChild.style.minWidth = '100px';
					}
					else {
						PVI.PrevDIV.lastChild.style.whiteSpace = 'nowrap';
						PVI.PrevDIV.lastChild.style.minWidth = '0';
					}
				}
			}
			else if (keyCode === cfg.tools['key_prefs']) { oex.postMessage({'cmd': 'open', 'url': 'options.html'}); }
			else if (keyCode === cfg.tools['key_imgSearch']) { imageSearch({'url': PVI.PrevOBJ.data, 'nf': ev.shiftKey}); if (!ev.shiftKey) { PVI.fastHide(); } }
			else if (PVI.PrevOBJ.data && (keyCode === 90 || keyCode === 13)) {
				if (PVI.fullZoom) {
					PVI.reset();
					!PVI.iFrame && win.removeEventListener('mousemove', PVI.m_move, false);
					return;
				}

				PVI.PrevDIV.style['OTransition'] = 'all 0';
				PVI.PrevOBJ.style['OTransition'] = 'all 0';
				PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = 'none';
				PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';

				PVI.fullZoom = true;
				PVI.m_move({'first': true, 'clientX': PVI.xy[0], 'clientY': PVI.xy[1]});
				!PVI.iFrame && win.addEventListener('mousemove', PVI.m_move, false);
			}
		}
	},
	m_over: function (ev) {
		if (((ev.fromElement || {}).imagus_ && !PVI.hiding && ev.target == PVI.target) || (ev.toElement || {}).imagus_) { return; }

		if ((ev.target.imagus_link_node && ev.target.imagus_link_node.href != ev.target.imagus_link_url) || (ev.target.imagus_img_src && ev.target.imagus_img_src != ev.target.src)) {
			delete ev.target.imagus_cache;
			delete ev.target.imagus_cache_resolved;
		}

		if (ev.target.imagus_cache === true || PVI.fullZoom || (!cfg.hz['deactivate'] && cfg.hz['actTrigger'] && !ev[cfg.hz['actTrigger'] + 'Key']) ||
				(cfg.hz['deactivate'] && (!cfg.hz['actTrigger'] || ev[cfg.hz['actTrigger'] + 'Key']))) { return; }

		var imgsrc, cache = ev.target.imagus_cache;

		PVI.target = ev.target;

		if (!cache && PVI.target.imagus_cache_resolved && PVI.target.imagus_cache_resolved !== true) {
			imgsrc = PVI.target.imagus_cache_resolved;
			cache = false;
		}

		if (cache || (imgsrc = imgsrc || PVI.find()) || imgsrc === null) {
			PVI.fireHide = true;

			if (imgsrc && !PVI.target.imagus_cache_resolved) {
				if (cfg.hz['preload'] && cfg.hz['hoverTime'] > 100 && typeof imgsrc == 'string' && !PVI.imageStack[imgsrc]) {
					new Image().src = imgsrc;
					PVI.imageStack[imgsrc] = true;
				}

				PVI.target.imagus_cache_resolved = imgsrc;
			}

			PVI.collectxy = true;

			if (cfg.hz['outline']) {
				(typeof PVI.target.origOutline == 'string') || (PVI.target.origOutline = PVI.target.style.outline);
				PVI.target.style.outline = '1px solid ' + (PVI.target.imagus_SVG ? 'blue' : 'red');
			}

			!PVI.iFrame && win.addEventListener('mousemove', PVI.m_move, false);

			clearTimeout(PVI.timers.preview);

			// TODO: wait for hide
			if (/*PVI.hiding && !cfg.hz['waitHide'] || */cfg.hz['hoverTime'] <= 50) {
				//PVI.hiding = false;
				PVI.load(ev, cache, imgsrc);
				return;
			}

			PVI.timers.preview = setTimeout(PVI.load, /*PVI.hiding && cfg.hz['waitHide'] ? Math.min(cfg.hz['fade'], cfg.hz['sizing'], cfg.hz['position']) + 100 :*/ cfg.hz['hoverTime'], ev, cache, imgsrc);
		}
		else {
			PVI.target.imagus_cache = true;
		}
	},
	load: function (ev, cache, imgsrc) {
		PVI.target.imagus_xy = {x1: ev.clientX - ev.offsetX, y1: ev.clientY - ev.offsetY};
		PVI.target.imagus_xy.x2 = PVI.target.imagus_xy.x1 + PVI.target.offsetWidth;
		PVI.target.imagus_xy.y2 = PVI.target.imagus_xy.y1 + PVI.target.offsetHeight;

		win.addEventListener('keypress', PVI.key_action, false);
		cfg.hz['hideOnScroll'] && doc.addEventListener('mousewheel', PVI.fastHide, false);

		cfg.hz['outline'] && (PVI.target.style.outline = '0');

		if (imgsrc === null) {
			PVI.create();
			PVI.show('Resova...');
			return;
		}

		if (cache || (typeof imgsrc == 'string' && Array.isArray(PVI.imageStack[imgsrc]))) {
			PVI.create();
			delete PVI.PrevOBJ.data;
			PVI.PrevOBJ.data = cache ? PVI.target.imagus_cache : (PVI.target.imagus_cache = imgsrc);
			PVI.show();
			return;
		}

		PVI.set(imgsrc);
	},
	m_move: function (ev) {
		if (PVI.fullZoom) {
			var
				w = PVI.imageStack[PVI.target.imagus_cache][0],
				h = PVI.imageStack[PVI.target.imagus_cache][1],
				winW = Math.max(PVI.bdy.clientWidth, root.clientWidth),
				winH = PVI.helper_div.clientHeight;

			w = (ev.first ? w : PVI.PrevOBJ.clientWidth) + PVI.PrevDIV.outsize - cfg.hz['margin'] * 2;
			h = (ev.first ? h : PVI.PrevOBJ.clientHeight) + PVI.PrevDIV.outsize - cfg.hz['margin'] * 2;

			(winW > win.innerWidth) && (winW = win.innerWidth);
			//winH = win.innerHeight - ( winW < Math.max(PVI.bdy.scrollWidth, root.scrollWidth) ? win.innerWidth - winW : 0);

			PVI.PrevDIV.style.left = w > winW ? (-(ev.clientX * (w - winW + 100) / winW) + 50) + 'px' : ((winW - w) / 2) + 'px';
			PVI.PrevDIV.style.top = h > winH ? (-(ev.clientY * (h - winH + 100) / winH) + 50) + 'px' : ((winH - h) / 2) + 'px';

			return;
		}

		if (PVI.collectxy/* && (!cfg.hz['deactivate'] && ev[cfg.hz['actTrigger'] + 'Key'])*/) {
			PVI.xy[0] = ev.clientX;
			PVI.xy[1] = ev.clientY;

			if ((!cfg.hz['deactivate'] && cfg.hz['actTrigger'] && !ev[cfg.hz['actTrigger'] + 'Key']) ||
				(cfg.hz['deactivate'] && (!cfg.hz['actTrigger'] || ev[cfg.hz['actTrigger'] + 'Key']))) { return; }
			else if (ev.target.imagus_ && PVI.target.imagus_xy &&
				(PVI.target.imagus_xy.x1 > ev.clientX || PVI.target.imagus_xy.x2 < ev.clientX || PVI.target.imagus_xy.y1 > ev.clientY || PVI.target.imagus_xy.y2 < ev.clientY) ||
				(!ev.target.imagus_ && PVI.target != ev.target)) {
				PVI.hide({'force': true, 'target': PVI.target, clientX: ev.clientX, clientY: ev.clientY}, true);
			}
			else if (cfg.hz['placement'] < 2 && !PVI.hiding && cfg.hz['move'] && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
				PVI.show();
			}
		}
	},
	fastHide: function () {
		//if (PVI.fullZoom) { return; }
		!PVI.iFrame && win.removeEventListener('mousemove', PVI.m_move, false);
		PVI.reset();
		doc.removeEventListener('mousewheel', PVI.fastHide, false);
	},
	onMessage: function (e) {
		if (e.data['hello']) { return; }
		PVI.create();

		if (e.data['cmd'] == 'resolved') {
			if (!e.data['m']) {
				PVI.PrevOBJ.innerText = 'Faila...';
			}
			else {
				if (PVI.target.src && PVI.target.src == e.data['m']) {
					PVI.target.imagus_cache = true;
					PVI.reset();
					cfg.hz['outline'] && (PVI.target.style.outline = '1px solid purple');
					return;
				}

				if (PVI.resolving.nodes[e.data.id] === PVI.target) {
					PVI.set(e.data['m']);
					PVI.target.imagus_cache_resolved = true;
				}
				else {
					/*if (cfg.hz['preload'] && cfg.hz['hoverTime'] > 100 && !PVI.imageStack[e.data.m]) {
						new Image().src = e.data.m;
						PVI.imageStack[e.data.m] = true;
					}*/

					PVI.resolving.nodes[e.data.id].imagus_cache_resolved = e.data['m'];
				}
			}
		}
		else if (e.data['cmd'] == 'svg_info') {
			var url = e.data['url'].replace(/#IMAGUS_SVG.*/, '');

			if (!e.data['svg']) {
				PVI.PrevOBJ.innerText = 'Erray! no SVG...';
				return;
			}

			if (!PVI.imageStack[url]) {
				var w = e.data['wh']['w'], h = e.data['wh']['h'];

				if (cfg.hz['svgsale'] === 1) {
					h = 400 / (w / h);
					w = 400;
				}
				else if (cfg.hz['svgsale'] === 2) {
					h = (win.innerWidth / 2) / (w / h);
					w = win.innerWidth / 2;
				}
				else if (cfg.hz['svgsale'] === 4) {
					h = win.screen.width / (w / h);
					w = win.screen.width;
				}

				PVI.imageStack[url] = [w, h];
			}

			if (PVI.PrevDIV.childElementCount > 1 && PVI.PrevDIV.lastChild.nodeName.toUpperCase() == 'OBJECT') { PVI.PrevDIV.lastChild.data = ''; PVI.PrevDIV.removeChild(PVI.PrevDIV.lastChild); }
			clearInterval(PVI.timers.imload);

			PVI.PrevOBJ.innerText = '';
			PVI.PrevOBJ.data = PVI.target.imagus_cache = url;
			PVI.show();
		}
		// TODO: detect if image fits the actual frame, then don't send to top
		else if (e.data['cmd'] == 'from_frame') {
			PVI.target = PVI.helper_div;

			if (e.data['hide']) {
				PVI.hide({'force': true, 'target': PVI.target, clientX: PVI.PrevDIV.clientWidth / 2, clientY: PVI.PrevDIV.clientHeight / 2}, true);
				return;
			}

			PVI.xy = [0, 0];
			if (PVI.imageStack[e.data['img']]) { PVI.PrevOBJ.data = e.data['img']; PVI.show(); }
			else { PVI.set(e.data['img']); }
		}
		else if (e.data['cmd'] == 'reinit') {
			PVI.init(null, true);
			PVI.init(e);
		}
	},
	init: function (e, deinit) {
		if (deinit) {
			win.removeEventListener('mousemove', PVI.m_move, false);
			PVI.PrevDIV && root.removeChild(PVI.PrevDIV);
			PVI.PrevDIV = null;
			PVI.helper_div && root.removeChild(PVI.helper_div);
			PVI.helper_div = null;
		}
		else {
			cfg = e.data['prefs'];

			if ((!cfg.hz['deactivate'] && cfg.hz['actTrigger'] == '0') || notGranted('hz') || (function () { for (var x in cfg.sieve) { return false; } return true; })()) { return; }

			convertSieveFunctions();

			PVI.iFrame = win != win.top;
			oex.removeEventListener('message', PVI.init, false);
			oex.addEventListener('message', PVI.onMessage, false);
		}

		win[(deinit ? 'remove' : 'add') + 'EventListener']('mouseover', PVI.m_over, false);
		win[(deinit ? 'remove' : 'add') + 'EventListener']('mouseout', PVI.hide, false);
	}
};

if (!isRaster) {
	doc.addEventListener('DOMContentLoaded', function () {
		var i = 0; exclude = doc.querySelectorAll('html, html > body, html > body > *:NOT(SCRIPT)');

		for (; i < exclude.length; ++i) {
			exclude[i].imagus_cache = exclude[i].imagus_cache_resolved = true;
		}
	}, false);

	oex.addEventListener('message', PVI.init, false);
	oex.addEventListener('disconnect', function() { PVI.init(null, true); oex.ondisconnect = oex.onmessage = null; }, false);
}

oex.postMessage({'cmd': 'hello'});

})(window, document);